



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>AM335x(TQ335x)学习笔记——u-boot-2014.10移植</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">AM335x(TQ335x)学习笔记——u-boot-2014.10移植</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 08:41:27 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>根据最近移植u-boot-2014.10至TQ335x，基于这样的假设am335x evm移植。不是很多地方需要改变。</p>
<p>因为TI的am335x evm开发了使用eeprom船上保存配置信息。它使用不同类型的电路板来区分，和TQ335x如果没有这个eeprom。因此。须要改动eeprom相关的部分，使u-boot适应TQ335x开发板。</p>
<p>使用source insight查看代码，非常easy发现，全部获取板载配置的部分都是通过读取eeprom获得的，因此，首选改动read_eeprom（board/ti/am335x/board.c）函数。详细的改动例如以下：</p>
<pre class="prettyprint linenums">static int read_eeprom(struct am335x_baseboard_id *header)<br />
{<br />
#if 1<br />
	strcpy(header-&gt;name, &quot;TQ335x&quot;);<br />
#else<br />
	/* Check if baseboard eeprom is available */<br />
	if (i2c_probe(CONFIG_SYS_I2C_EEPROM_ADDR)) {<br />
		puts(&quot;Could not probe the EEPROM; something fundamentally &quot;<br />
			&quot;wrong on the I2C bus.\n&quot;);<br />
		return -ENODEV;<br />
	}

	/* read the eeprom using i2c */<br />
	if (i2c_read(CONFIG_SYS_I2C_EEPROM_ADDR, 0, 2, (uchar *)header,<br />
		     sizeof(struct am335x_baseboard_id))) {<br />
		puts(&quot;Could not read the EEPROM; something fundamentally&quot;<br />
			&quot; wrong on the I2C bus.\n&quot;);<br />
		return -EIO;<br />
	}

	if (header-&gt;magic != 0xEE3355AA) {<br />
		/*<br />
		 * read the eeprom using i2c again,<br />
		 * but use only a 1 byte address<br />
		 */<br />
		if (i2c_read(CONFIG_SYS_I2C_EEPROM_ADDR, 0, 1, (uchar *)header,<br />
			     sizeof(struct am335x_baseboard_id))) {<br />
			puts(&quot;Could not read the EEPROM; something &quot;<br />
				&quot;fundamentally wrong on the I2C bus.\n&quot;);<br />
			return -EIO;<br />
		}

		if (header-&gt;magic != 0xEE3355AA) {<br />
			printf(&quot;Incorrect magic number (0x%x) in EEPROM\n&quot;,<br />
					header-&gt;magic);<br />
			return -EINVAL;<br />
		}<br />
	}<br />
#endif

	return 0;<br />
}</pre>
<p>通过上述改动，u-boot不去读取eeprom，而是直接将header的name赋&#20540;为&quot;TQ335x&quot;，后面能够依据这一配置区分是否为TQ335x开发板。</p>
<p>然后是改动get_dpll_ddr_params（board/ti/am335x/board.c）函数，详细的改动内容例如以下：</p>
<pre class="prettyprint linenums">const struct dpll_params *get_dpll_ddr_params(void)<br />
{<br />
	struct am335x_baseboard_id header;

	enable_i2c0_pin_mux();<br />
	i2c_init(CONFIG_SYS_OMAP24_I2C_SPEED, CONFIG_SYS_OMAP24_I2C_SLAVE);<br />
	if (read_eeprom(&amp;header) &lt; 0)<br />
		puts(&quot;Could not get board ID.\n&quot;);

	if (board_is_tq335x(&amp;header) || board_is_evm_sk(&amp;header))<br />
		return &amp;dpll_ddr_evm_sk;<br />
	else if (board_is_bone_lt(&amp;header))<br />
		return &amp;dpll_ddr_bone_black;<br />
	else if (board_is_evm_15_or_later(&amp;header))<br />
		return &amp;dpll_ddr_evm_sk;<br />
	else<br />
		return &amp;dpll_ddr;<br />
}</pre>
<p>然后是改动sdram_init（board/ti/am335x/board.c）函数，详细的改动内容例如以下：
<pre class="prettyprint linenums">void sdram_init(void)<br />
{<br />
	__maybe_unused struct am335x_baseboard_id header;

	if (read_eeprom(&amp;header) &lt; 0)<br />
		puts(&quot;Could not get board ID.\n&quot;);

	if (board_is_evm_sk(&amp;header)) {<br />
		/*<br />
		 * EVM SK 1.2A and later use gpio0_7 to enable DDR3.<br />
		 * This is safe enough to do on older revs.<br />
		 */<br />
		gpio_request(GPIO_DDR_VTT_EN, &quot;ddr_vtt_en&quot;);<br />
		gpio_direction_output(GPIO_DDR_VTT_EN, 1);<br />
	}

	if (board_is_evm_sk(&amp;header) || board_is_tq335x(&amp;header))<br />
		config_ddr(303, &amp;ioregs_evmsk, &amp;ddr3_data,<br />
			   &amp;ddr3_cmd_ctrl_data, &amp;ddr3_emif_reg_data, 0);<br />
	else if (board_is_bone_lt(&amp;header))<br />
		config_ddr(400, &amp;ioregs_bonelt,<br />
			   &amp;ddr3_beagleblack_data,<br />
			   &amp;ddr3_beagleblack_cmd_ctrl_data,<br />
			   &amp;ddr3_beagleblack_emif_reg_data, 0);<br />
	else if (board_is_evm_15_or_later(&amp;header))<br />
		config_ddr(303, &amp;ioregs_evm15, &amp;ddr3_evm_data,<br />
			   &amp;ddr3_evm_cmd_ctrl_data, &amp;ddr3_evm_emif_reg_data, 0);<br />
	else<br />
		config_ddr(266, &amp;ioregs, &amp;ddr2_data,<br />
			   &amp;ddr2_cmd_ctrl_data, &amp;ddr2_emif_reg_data, 0);<br />
}</pre>
<p>然后加入board_is_tq335x函数的详细实现，參考其他类&#20284;函数实现就可以，因为我们的read_eeprom仅读到了name，其内容是&quot;TQ335x&quot;，故可例如以下实现。在board/ti/am335x/board.h中加入例如以下内容：
<pre class="prettyprint linenums">static inline int board_is_tq335x(struct am335x_baseboard_id *header)<br />
{<br />
	return !strncmp(header-&gt;name, &quot;TQ335x&quot;, HDR_NAME_LEN);<br />
}</pre>
<p>最后是改动enable_board_pin_mux（board/ti/am335x/mux.c）函数，详细的改动内容例如以下：
<pre class="prettyprint linenums">void enable_board_pin_mux(struct am335x_baseboard_id *header)<br />
{<br />
	/* Do board-specific muxes. */<br />
	if (board_is_bone(header) || board_is_tq335x(header)) {<br />
		/* Beaglebone pinmux */<br />
		configure_module_pin_mux(i2c1_pin_mux);<br />
		configure_module_pin_mux(mii1_pin_mux);<br />
		configure_module_pin_mux(mmc0_pin_mux);<br />
#if defined(CONFIG_NAND)<br />
		configure_module_pin_mux(nand_pin_mux);<br />
#elif defined(CONFIG_NOR)<br />
		configure_module_pin_mux(bone_norcape_pin_mux);<br />
#else<br />
		configure_module_pin_mux(mmc1_pin_mux);<br />
#endif<br />
	} else if (board_is_gp_evm(header)) {<br />
		/* General Purpose EVM */<br />
		unsigned short profile = detect_daughter_board_profile();<br />
		configure_module_pin_mux(rgmii1_pin_mux);<br />
		configure_module_pin_mux(mmc0_pin_mux);<br />
		/* In profile #2 i2c1 and spi0 conflict. */<br />
		if (profile &amp; ~PROFILE_2)<br />
			configure_module_pin_mux(i2c1_pin_mux);<br />
		/* Profiles 2 &amp; 3 don&#039;t have NAND */<br />
#ifdef CONFIG_NAND<br />
		if (profile &amp; ~(PROFILE_2 | PROFILE_3))<br />
			configure_module_pin_mux(nand_pin_mux);<br />
#endif<br />
		else if (profile == PROFILE_2) {<br />
			configure_module_pin_mux(mmc1_pin_mux);<br />
			configure_module_pin_mux(spi0_pin_mux);<br />
		}<br />
	} else if (board_is_idk(header)) {<br />
		/* Industrial Motor Control (IDK) */<br />
		configure_module_pin_mux(mii1_pin_mux);<br />
		configure_module_pin_mux(mmc0_no_cd_pin_mux);<br />
	} else if (board_is_evm_sk(header)) {<br />
		/* Starter Kit EVM */<br />
		configure_module_pin_mux(i2c1_pin_mux);<br />
		configure_module_pin_mux(gpio0_7_pin_mux);<br />
		configure_module_pin_mux(rgmii1_pin_mux);<br />
		configure_module_pin_mux(mmc0_pin_mux_sk_evm);<br />
	} else if (board_is_bone_lt(header)) {<br />
		/* Beaglebone LT pinmux */<br />
		configure_module_pin_mux(i2c1_pin_mux);<br />
		configure_module_pin_mux(mii1_pin_mux);<br />
		configure_module_pin_mux(mmc0_pin_mux);<br />
#if defined(CONFIG_NAND)<br />
		configure_module_pin_mux(nand_pin_mux);<br />
#elif defined(CONFIG_NOR)<br />
		configure_module_pin_mux(bone_norcape_pin_mux);<br />
#else<br />
		configure_module_pin_mux(mmc1_pin_mux);<br />
#endif<br />
	} else {<br />
		puts(&quot;Unknown board, cannot configure pinmux.&quot;);<br />
		hang();<br />
	}<br />
}</pre>
<p>另外，这个版本号的u-boot有个bug。须要改动fat_register_device（fs/fat/fat.c）函数：</p>
<pre class="prettyprint linenums">int fat_register_device(block_dev_desc_t *dev_desc, int part_no)<br />
{<br />
	disk_partition_t info;

	/* First close any currently found FAT filesystem */<br />
	cur_dev = NULL;

	/* Read the partition table, if present */<br />
	if (get_partition_info(dev_desc, part_no, &amp;info)) {<br />
		/*if (part_no != 0) {<br />
			printf(&quot;** Partition %d not valid on device %d **\n&quot;,<br />
					part_no, dev_desc-&gt;dev);<br />
			return -1;<br />
		}*/

		info.start = 0;<br />
		info.size = dev_desc-&gt;lba;<br />
		info.blksz = dev_desc-&gt;blksz;<br />
		info.name[0] = 0;<br />
		info.type[0] = 0;<br />
		info.bootable = 0;<br />
#ifdef CONFIG_PARTITION_UUIDS<br />
		info.uuid[0] = 0;<br />
#endif<br />
	}

	return fat_set_blk_dev(dev_desc, &amp;info);<br />
}</pre>
<p>至此，u-boot就已经能够启动了，可是有多余的步骤和log。只是能够去掉。改动file_fat_read_at（fs/fat/fat.c）函数：</p>
<pre class="prettyprint linenums">long file_fat_read_at(const char *filename, unsigned long pos, void *buffer,<br />
		      unsigned long maxsize)<br />
{<br />
	debug(&quot;reading %s\n&quot;, filename);<br />
	return do_fat_read_at(filename, pos, buffer, maxsize, LS_NO, 0);<br />
}</pre>
<p>最后，TQ335x是MLO启动u-boot。然后u-boot去启动内核。故能够去掉配置项CONFIG_SPL_OS_BOOT，详细的改动文件include/configs/ti_armv7_common.h：</p>
<pre class="prettyprint linenums">#if defined(CONFIG_SPL_OS_BOOT_ENABLE)<br />
#define CONFIG_SPL_OS_BOOT<br />
#endif</pre>
<p>至此，u-boot的移植工作就完毕了，编译方法例如以下：</p>
<pre class="prettyprint linenums">make ARCH=arm CROSS_COMPILE=arm-linux-gnueabi- am335x_evm_defconfig<br />
make ARCH=arm CROSS_COMPILE=arm-linux-gnueabi- -j8</pre>
<p>当中，arm-linux-gnueabi-须要依据自己的交叉编译工具链前缀进行改动。完毕u-boot的移植工作后我们来研究怎样启动内核。</p>
<p>源代码下载地址：</p>
<p><a href="http://download.csdn.net/detail/girlkoo/8316233" rel="external nofollow noreferrer">u-boot-2014.10 for TQ335x/TQ3358(SD卡启动)</a></p>
<p>本文作者：girlkoo</p>
<p>本文链接：<a href="http://blog.csdn.net/girlkoo/article/details/41183217" rel="external nofollow noreferrer">http://blog.csdn.net/girlkoo/article/details/41183217</a></p>
<div>
<p>版权声明：本文博客原创文章，博客，未经同意，不得转载。</p></p></div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pj7xy9.html">&lbrack;LeetCode&rsqb; Combination Sum IV 组合之和之四</a>
		</li>
						<li><a href="https://www.batexi.com/a/390m03n8.html">Linux 操作mysql数据库 创建库 导入、删除表</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlnl468.html">Python 开平方</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rlen79.html">LPCTSTR 用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4o5zj8.html">VS快捷键设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjwz5y9.html">Android开发-API指南-数据存储</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e13x7z9.html">lex&amp;amp&semi;yacc8--wehter use in C&plus;&plus;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y3jw5q.html">SaaS系列介绍之十&colon; SaaS的商业模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnj76v8.html">一种轻量的openresty路由设计</a>
		</li>
						<li><a href="https://www.batexi.com/a/950d0nm8.html">Vue&period;js 基础指令实例讲解（各种数据绑定、表单渲染大总结）&mdash;&mdash;新手入门、高手进阶</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd7no49.html">spring boot &sol; cloud &lpar;三&rpar; 集成springfox-swagger2构建在线API文档</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pkyny8.html">校验Linux程序是否被黑客修改</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpyx779.html">sizeof和strlen&lpar;&rpar;区别及用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eypjvk9.html">java&period;util中，util是什么意思</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2n5j2q.html">ROS tf</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o14zzlq.html">vue编程式导航</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllvrl0q.html">lmbench用于arm测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j0yd0q.html">SqlServer2008备份与还原（完整图示版）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r33408.html">Linux系统运维故障排查</a>
		</li>
						<li><a href="https://www.batexi.com/a/963jr0v9.html">PAT甲题题解-1077&period; Kuchiguse &lpar;20&rpar;-找相同后缀</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qxkn0jd8.html">如何在 Windows Phone 8 中获取手机的当前位置</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mm7k38.html">将鼠标移到文本弹出一些字幕CSS达到，不及格JS达到</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkkny08.html">&period;net读取异步Post的内容</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pddjed9.html">使用scipy进行聚类</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkknve8.html">【剑指offer】面试题26：复制的复杂链条</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjjd238.html">postgresql数据库配置csv格式的日志输出</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv111d1q.html">bnu1066</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pddd2d9.html">Windows Phone开发（26）：启动器与选择器之MediaPlayerLauncher和SearchTask</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzzmnw8.html">Django操作model时刻，一个错误：AttributeError&colon;&rsquo;ProgrammingError&rsquo; object has no attribute &OpenCurlyQuote;&lowbar;&lowbar;traceback&lowbar;&lowbar;&rsquo;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zzpe59.html">深度分析 Java 的 ClassLoader 机制（源码级别）（转）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
